// $Id: cwind.cpp 1.7 2003/05/17 13:32:10 s-imai s-imai $
//
// Copyright (C) 2000-2003 Satoshi Imai
//

#include "cwind.h"

//
// CwindpbP[W
//

// \
static struct ProcArg {
	char *winText;		// (I) EBhEeLXg
	HWND hTarget;		// (O) EBhEnh
	Tcl_Interp *interp;	// (I) C^v^
	BOOL fExact;		// (I) 񌟍IvV
	BOOL fChild;		// (I) MDIqEBhE
} ProcArg;

// X[v
static DWORD sleeptime = 0;

//
// R[obN֐(Findp)
//
BOOL CALLBACK
EnumFindProc(
	HWND hWnd,
	LPARAM lParam
)
{
	char *text;
	int len;
	Tcl_DString dString;

	// EBhEeLXg̃TCY`FbN
	if((len = GetWindowTextLength(hWnd)) < 1) {
		return TRUE;
	}
	if(!IsWindowVisible(hWnd)) {
		return TRUE;
	}
//	if(GetWindow(hWnd, GW_OWNER)) {
//		return TRUE;
//	}
	// EBhEeLXg̈m
	text = Tcl_Alloc(len+1);
	if(text == NULL) {
		return TRUE;
	}
	// EBhEeLXg̎擾
	GetWindowText(hWnd, text, len+1);
	// SJISUNICODE֕ϊ
	Tcl_ExternalToUtfDString(NULL, text, len, &dString);

	// ƃEBhEeLXg̔r
	if(((struct ProcArg *)lParam)->fExact == TRUE) {
		if(!strcmp(Tcl_DStringValue(&dString), ((struct ProcArg *)lParam)->winText)) {
			((struct ProcArg *)lParam)->hTarget = hWnd;
			goto found;
		}
	}
	else {
		if(Tcl_StringMatch(Tcl_DStringValue(&dString), ((struct ProcArg *)lParam)->winText)) {
			((struct ProcArg *)lParam)->hTarget = hWnd;
			goto found;
		}
	}

	Tcl_DStringFree(&dString);
	Tcl_Free(text);
	return TRUE;

found:
	Tcl_DStringFree(&dString);
	Tcl_Free(text);
	return FALSE;
}

//
// R[obN֐(Listp)
//
BOOL CALLBACK
EnumListProc(
	HWND hWnd,
	LPARAM lParam
)
{
	char *text;
	int len;
	Tcl_DString dString;

	// EBhEeLXg̃TCY`FbN
	if((len = GetWindowTextLength(hWnd)) < 1) {
		return TRUE;
	}
	if(!IsWindowVisible(hWnd)) {
		return TRUE;
	}
//	if(GetWindow(hWnd, GW_OWNER)) {
//		return TRUE;
//	}
	// MDIEBhEǂׂ
	if(((struct ProcArg *)lParam)->fChild == TRUE) {
		HMODULE hmodule = GetModuleHandle("USER32.DLL");
		typedef int (FAR PASCAL *WINPROC) (HWND hwnd, PWINDOWINFO pwi);
		WINPROC proc = (WINPROC)GetProcAddress(hmodule, "GetWindowInfo");
		if(proc) {
			WINDOWINFO wi;
			if(proc(hWnd, &wi) && !(wi.dwExStyle & WS_EX_MDICHILD)) {
				return TRUE;
			}
		}
	}
	// EBhEeLXg̈m
	text = Tcl_Alloc(len+1);
	if(text == NULL) {
		return TRUE;
	}
	// EBhEeLXg̎擾
	GetWindowText(hWnd, text, len+1);
	// SJISUNICODE֕ϊ
	Tcl_ExternalToUtfDString(NULL, text, len, &dString);

	// ʂݒ
	Tcl_AppendElement(((struct ProcArg *)lParam)->interp, Tcl_DStringValue(&dString));

	Tcl_DStringFree(&dString);
	Tcl_Free(text);
	return TRUE;
}

//
// GetHwndR}h
//
static int
Cwind_GetTextObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	char *text;
	int len;
	Tcl_DString dString;

	// EBhEeLXg̃TCY`FbN
	if((len = GetWindowTextLength(GetForegroundWindow())) < 0) {
		Tcl_AppendResult(interp, "WindowText is empty.", NULL);
		return TCL_ERROR;
	}
	// EBhEeLXg̈m
	text = Tcl_Alloc(len+1);
	if(text == NULL) {
		return TCL_ERROR;
	}
	// tHAOhEEBhẼEBhEeLXg̎擾
	GetWindowText(GetForegroundWindow(), text, len+1);
	// SJISUNICODE֕ϊ
	Tcl_ExternalToUtfDString(NULL, text, len, &dString);
	
	Tcl_AppendResult(interp, Tcl_DStringValue(&dString), NULL);
	Tcl_DStringFree(&dString);
	Tcl_Free(text);
	return TCL_OK;
}

//
// BottomR}h
//
static int
Cwind_BottomObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}
	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = Tcl_GetString(objv[1]);
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			return TCL_ERROR;
		}
	}

	// EBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		return TCL_ERROR;
	}

	// EBhE Z ̈ԉɒu܂
	SetWindowPos(ProcArg.hTarget, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	return TCL_OK;
}

//
// TopR}h
//
static int
Cwind_TopObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}
	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = Tcl_GetString(objv[1]);
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			return TCL_ERROR;
		}
	}

	// EBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		return TCL_ERROR;
	}

	// EBhE Z ̐擪ɒu܂
	SetWindowPos(ProcArg.hTarget, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	return TCL_OK;
}

//
// TopMostR}h
//
static int
Cwind_TopMostObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}
	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = Tcl_GetString(objv[1]);
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			return TCL_ERROR;
		}
	}

	// EBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		return TCL_ERROR;
	}

	// EBhEׂĂ̔ŏʃEBhȄɒu܂
	SetWindowPos(ProcArg.hTarget, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	return TCL_OK;
}

//
// NoTopMostR}h
//
static int
Cwind_NoTopMostObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}
	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = Tcl_GetString(objv[1]);
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			return TCL_ERROR;
		}
	}

	// EBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		return TCL_ERROR;
	}

	// EBhEׂĂ̔ŏʃEBhE̐擪ɍĔzu܂ 
	SetWindowPos(ProcArg.hTarget, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
	return TCL_OK;
}

//
// ShowR}h
//
static int
Cwind_ShowObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	int argc;
	char **argv;
	HWND hParent;

	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}

	// eEBhEƎqEBhEɕ
	if(Tcl_SplitList(interp, Tcl_GetString(objv[1]), &argc, &argv) != TCL_OK)
	        return TCL_ERROR;
	// EBhẼXg`FbN
	if(argc == 0) {
        	Tcl_AppendResult(interp, "No such window name.", NULL);
		return TCL_ERROR;
	}

	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = argv[0];
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			goto error;
		}
	}

	// eEBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		goto error;
	}

	hParent = ProcArg.hTarget;

	// qEBhE
	if(argc > 1) {
		ProcArg.hTarget = NULL;
		ProcArg.winText = argv[1];
		EnumChildWindows(hParent, EnumFindProc, (LPARAM)&ProcArg);
		if (ProcArg.hTarget == NULL) {
			Tcl_AppendResult(interp, "No such window exists.", NULL);
			goto error;
		}
	}

	// eEBhETOPֈړ
	if(!MySetForegroundWindow(hParent)) {
		ShowWindow(hParent, SW_MINIMIZE);
		ShowWindow(hParent, SW_RESTORE);
	}

	if(argc > 1) {
		// qEBhETOPֈړ
		BringWindowToTop(ProcArg.hTarget);
	}

	// ACR̓m[}ɖ߂
	if(IsIconic(ProcArg.hTarget)) {
		ShowWindow(ProcArg.hTarget, SW_RESTORE);
	}

	Tcl_Free((char *)argv);
	return TCL_OK;

error:
	Tcl_Free((char *)argv);
	return TCL_ERROR;
}

//
// XyVELN^̌
//
BOOL
ScLookup(
	char *name,	// (I) XyVELN^
	BYTE *vkey,	// (O) zL[
	DWORD *isup	// (O) UPtO
) {
	struct SpecialChar *psc;

	psc = &SpecialChar[0];
	for(int i = 0; psc[i].sc_name ;i++) {
		if((psc[i].sc_name[0] == name[0]) &&
				!stricmp(psc[i].sc_name, name)) {
			*vkey = psc[i].sc_vkey;
			*isup = psc[i].sc_flag;
			return TRUE;
		}
	}
	return FALSE;
}

//
// WindowsbZ[W̌
// 
UINT
WmLookup(
	Tcl_Interp *interp,
	char *str
) {
	struct WmCommand *wmc;
	UINT cmd;

	if(Tcl_GetInt(interp, str, (int *)&cmd) == TCL_OK) {
		return cmd;
	}
	Tcl_ResetResult(interp);
	wmc = &WmCommand[0];
	for(int i = 0; wmc[i].str ;i++) {
		if((wmc[i].str[0] == str[0]) && !stricmp(wmc[i].str, str)) {
			return wmc[i].cmd;
		}
	}
	return 0;
}

//
// SendR}h
//
static int
Cwind_SendObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	char *mesg;
	BYTE vkey;
	DWORD isup;
	BOOL iscap;
	SHORT code;

	// ̐`FbN
	if (objc < 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "string ...");
		return TCL_ERROR;
	}

	for(int i = 1; i < objc; i++) {
		mesg = Tcl_GetString(objv[i]);
		if(mesg == NULL) {
			Tcl_AppendResult(interp, "No message exists.", NULL);
			return TCL_ERROR;
		}
		// XyVELN^̌
		if(ScLookup(mesg, &vkey, &isup)) {
			// XyVELN^
			if(sleeptime) Sleep(sleeptime);
			keybd_event(vkey, 0, isup, 0);
			if((vkey == VK_MENU) || (vkey == VK_CONTROL) || (vkey == VK_SHIFT))
				continue;
			keybd_event(vkey, 0, KEYEVENTF_KEYUP, 0);
		}
		else {
			// m[}ELN^
			Tcl_UniChar *us=Tcl_GetUnicode(objv[i]);
			for( ;*us; us++) {
				if(sleeptime) Sleep(sleeptime);
				if(*us>255) {
					Tcl_AppendResult(interp, "can't send Unicode character.", NULL);
					return TCL_ERROR;
				}
				code = VkKeyScan((char)*us);
				vkey = LOBYTE(code);
				iscap = HIBYTE(code);
				if(iscap&1) keybd_event(VK_SHIFT, 0, 0, 0);
				if(iscap&2) keybd_event(VK_CONTROL, 0, 0, 0);
				if(iscap&4) keybd_event(VK_MENU, 0, 0, 0);
				keybd_event(vkey, 0, 0, 0);
				keybd_event(vkey, 0, KEYEVENTF_KEYUP, 0);
				if(iscap&4) keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0);
				if(iscap&2) keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
				if(iscap&1) keybd_event(VK_SHIFT, 0, KEYEVENTF_KEYUP, 0);
			}
		}
	}
	return TCL_OK;
}

//
// GetcbR}h
//
static int
Cwind_GetCbObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	if(!OpenClipboard(NULL)) {
		Tcl_AppendResult(interp, "Cannot open clipboard.", NULL);
		return TCL_ERROR;
	}
	if(!IsClipboardFormatAvailable(CF_TEXT)) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Clipboard is empty.", NULL);
		return TCL_ERROR;
	}
	HANDLE hClip = GetClipboardData(CF_TEXT);
	if (!hClip) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Cannot get clipboard data.", NULL);
		return TCL_ERROR;
	}
	LPVOID pClip = GlobalLock(hClip);
	if (!pClip) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Cannot lock clipboard.", NULL);
		return TCL_ERROR;
	}
	DWORD len = strlen((char *)pClip);
	if(len == 0) {
		GlobalUnlock(hClip);
		CloseClipboard();
		Tcl_AppendResult(interp, "Clipboard data size is zero.", NULL);
		return TCL_ERROR;
	}
	char *pbuf = Tcl_Alloc(len+1);
	if (pbuf == NULL) {
		GlobalUnlock(hClip);
		CloseClipboard();
		Tcl_AppendResult(interp, "Not enough memory.", NULL);
		return TCL_ERROR;
	}
	memcpy(pbuf, pClip, len);
	pbuf[len] = '\0';

	Tcl_DString dString;
	// SJISUNICODE֕ϊ
	Tcl_ExternalToUtfDString(NULL, pbuf, len, &dString);

	Tcl_AppendResult(interp, Tcl_DStringValue(&dString), NULL);

	GlobalUnlock(hClip);
	Tcl_Free(pbuf);
	Tcl_DStringFree(&dString);
	CloseClipboard();
	return TCL_OK;
}

//
// PutcbR}h
//
static int
Cwind_PutCbObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	if (objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "string");
		return TCL_ERROR;
	}
	if(!OpenClipboard(NULL)) {
		Tcl_AppendResult(interp, "Cannot open clipboard.", NULL);
		return TCL_ERROR;
	}

	DWORD len = strlen(Tcl_GetString(objv[1]));
	Tcl_DString dString;
	// UNICODESJIS֕ϊ
	Tcl_UtfToExternalDString(NULL, Tcl_GetString(objv[1]), len, &dString);
	len = strlen(Tcl_DStringValue(&dString));

	HGLOBAL hClip = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, len+1);
	if (!hClip) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Not enough memory.", NULL);
		return TCL_ERROR;
	}
	LPVOID pClip = GlobalLock(hClip);
	if (!pClip) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Cannot lock memory.", NULL);
		return TCL_ERROR;
	}
	memcpy(pClip, Tcl_DStringValue(&dString), len);
	((char *)pClip)[len] = '\0';

	Tcl_DStringFree(&dString);
	GlobalUnlock(hClip);

	EmptyClipboard();
	if (!SetClipboardData(CF_TEXT, hClip)) {
		CloseClipboard();
		Tcl_AppendResult(interp, "Cannot set clipboard data.", NULL);
		return TCL_ERROR;
	}
	CloseClipboard();

	return TCL_OK;
}

//
// ListR}h
//
static int
Cwind_WlistObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	if(objc == 1) {
		// ̐ݒ
		ProcArg.interp = interp;
		ProcArg.fChild = FALSE;

		// EBhE
		EnumWindows(EnumListProc, (LPARAM)&ProcArg);

		return TCL_OK;
	}

	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}
	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = Tcl_GetString(objv[1]);
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			return TCL_ERROR;
		}
	}

	// EBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		return TCL_ERROR;
	}

	// ̐ݒ
	ProcArg.interp	= interp;
	ProcArg.fChild = TRUE;

	// EBhE
	EnumChildWindows(ProcArg.hTarget, EnumListProc, (LPARAM)&ProcArg);

	return TCL_OK;
}

//
// SleeptimeR}h
//
static int
Cwind_SleeptimeObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	char buf [100];
	int ret, num;

	// ̐`FbN
	if (objc == 1) {
		sprintf(buf, "%u", sleeptime);
		Tcl_AppendResult(interp, buf, NULL);
		// Q
	}
	else {
		// ݒ
		ret = Tcl_GetInt(interp, Tcl_GetString(objv[1]), &num);
		if(ret != TCL_OK) {
			return TCL_ERROR;
		}
		sleeptime = num;
	}

	return TCL_OK;
}

//
// RestoreR}h
//
static int
Cwind_RestoreObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// tHAOhEEBhẼnh擾
	HWND hWnd = GetForegroundWindow();
	// m[}ɖ߂
	ShowWindow(hWnd, SW_RESTORE);
//	UpdateWindow(hWnd);

	return TCL_OK;
}

//
// MinimizeR}h
//
static int
Cwind_MinimizeObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// tHAOhEEBhẼnh擾
	HWND hWnd = GetForegroundWindow();
	// ŏ
	ShowWindow(hWnd, SW_MINIMIZE);
//	UpdateWindow(hWnd);

	return TCL_OK;
}

//
// MaximizeR}h
//
static int
Cwind_MaximizeObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	// tHAOhEEBhẼnh擾
	HWND hWnd = GetForegroundWindow();
	// ő剻
	ShowWindow(hWnd, SW_MAXIMIZE);
//	UpdateWindow(hWnd);

	return TCL_OK;
}

//
// StateR}h
//
static int
Cwind_StateObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	int argc;
	char **argv;

	// ̐`FbN
	if ((objc != 2) && (objc != 3)) {
		Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
		return TCL_ERROR;
	}

	// eEBhEƎqEBhEɕ
	if(Tcl_SplitList(interp, Tcl_GetString(objv[1]), &argc, &argv) != TCL_OK)
	        return TCL_ERROR;
	// EBhẼXg`FbN
	if(argc == 0) {
        	Tcl_AppendResult(interp, "No such window name.", NULL);
		return TCL_ERROR;
	}

	// ̐ݒ
	ProcArg.hTarget = NULL;
	ProcArg.winText = argv[0];
	ProcArg.fExact = FALSE;

	// IvV`FbN
	if(objc == 3) {
		if(!strncmp(Tcl_GetString(objv[1]), "-exact", strlen(Tcl_GetString(objv[1])))) {
			ProcArg.fExact = TRUE;
			ProcArg.winText = Tcl_GetString(objv[2]);
		}
		else {
			Tcl_WrongNumArgs(interp, 1, objv, "?-exact? pattern");
			goto error;
		}
	}

	// eEBhE
	EnumWindows(EnumFindProc, (LPARAM)&ProcArg);

	// Ȃ̓G[Ԃ
	if (ProcArg.hTarget == NULL) {
		Tcl_AppendResult(interp, "No such window exists.", NULL);
		goto error;
	}

	// qEBhE
	if(argc > 1) {
		HWND hParent = ProcArg.hTarget;
		ProcArg.hTarget = NULL;
		ProcArg.winText = argv[1];
		EnumChildWindows(hParent, EnumFindProc, (LPARAM)&ProcArg);
		if (ProcArg.hTarget == NULL) {
			Tcl_AppendResult(interp, "No such window exists.", NULL);
			goto error;
		}
	}

	// Xe[^X\
	if(IsIconic(ProcArg.hTarget)) {
		Tcl_AppendResult(interp, "Minimized", NULL);
	}
	else if(IsZoomed(ProcArg.hTarget)) {
		Tcl_AppendResult(interp, "Maximized", NULL);
	}
	else {
		Tcl_AppendResult(interp, "Normal", NULL);
	}

	Tcl_Free((char *)argv);
	return TCL_OK;

error:
	Tcl_Free((char *)argv);
	return TCL_ERROR;
}

//
// SendmessageR}h
//
static int
Cwind_SendmessageObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	HWND hWnd;
	UINT msg;
	WPARAM wparam=0;
	LPARAM lparam=0;

	if((objc < 2) || (objc > 5)) {
		Tcl_WrongNumArgs(interp, 1, objv, "message ?wparam? ?lparam?");
		return TCL_ERROR;
	}
	msg = WmLookup(interp, Tcl_GetString(objv[1]));
	if(!msg) {
		Tcl_AppendResult(interp, "invalid message.", NULL);
		return TCL_ERROR;
	}
	if(objc > 2) {
		if(Tcl_GetInt(interp, Tcl_GetString(objv[2]), (int *)&wparam) != TCL_OK)
			return TCL_ERROR;
	}
	if(objc > 3) {
		if(Tcl_GetInt(interp, Tcl_GetString(objv[3]), (int *)&lparam) != TCL_OK)
			return TCL_ERROR;
	}
	hWnd = GetForegroundWindow();
	SendMessage(hWnd, msg, wparam, lparam);
	return TCL_OK;
}

//
// PostmessageR}h
//
static int
Cwind_PostmessageObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	HWND hWnd;
	UINT msg;
	WPARAM wparam=0;
	LPARAM lparam=0;

	if((objc < 2) || (objc > 5)) {
		Tcl_WrongNumArgs(interp, 1, objv, "message ?wparam? ?lparam?");
		return TCL_ERROR;
	}
	msg = WmLookup(interp, Tcl_GetString(objv[1]));
	if(!msg) {
		Tcl_AppendResult(interp, "invalid message.", NULL);
		return TCL_ERROR;
	}
	if(objc > 2) {
		if(Tcl_GetInt(interp, Tcl_GetString(objv[2]), (int *)&wparam) != TCL_OK)
			return TCL_ERROR;
	}
	if(objc > 3) {
		if(Tcl_GetInt(interp, Tcl_GetString(objv[3]), (int *)&lparam) != TCL_OK)
			return TCL_ERROR;
	}
	hWnd = GetForegroundWindow();
	PostMessage(hWnd, msg, wparam, lparam);
	return TCL_OK;
}

//
// GetposR}h (XN[W)
//
static int
Cwind_GetposObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	POINT point;
	char buf[100];
	
	if(GetCursorPos(&point) == 0) {
		Tcl_AppendResult(interp, "Cannot get cusor position.", NULL);
		return TCL_ERROR;
	}
	sprintf(buf, "%d %d", point.x, point.y);
	Tcl_AppendResult(interp, buf, NULL);
	return TCL_OK;
}

//
// GetwposR}h (NCAgW)
//
static int
Cwind_GetwposObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	POINT point;
	char buf[100];
	
	if(GetCursorPos(&point) == 0) {
		Tcl_AppendResult(interp, "Cannot get cusor position.", NULL);
		return TCL_ERROR;
	}
	if(ScreenToClient(GetForegroundWindow(), &point) == 0) {
		Tcl_AppendResult(interp, "Cannot convert from screen to client.", NULL);
		return TCL_ERROR;
	}
	sprintf(buf, "%d %d", point.x, point.y);
	Tcl_AppendResult(interp, buf, NULL);
	return TCL_OK;
}

//
// SetposR}h (XN[W)
//
static int
Cwind_SetposObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	POINT point;
	int argc;
	char **argv;
	
	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "{x y}");
		return TCL_ERROR;
	}
	// xy𕪗
	if(Tcl_SplitList(interp, Tcl_GetString(objv[1]), &argc, &argv) != TCL_OK)
	        return TCL_ERROR;
	if(argc != 2) {
        Tcl_AppendResult(interp, "No such cursor position.", NULL);
		if(argc != 0) {
			Tcl_Free((char *)argv);
		}
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[0], (int *)&point.x) != TCL_OK) {
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[1], (int *)&point.y) != TCL_OK) {
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	if(SetCursorPos(point.x, point.y) == 0) {
		Tcl_AppendResult(interp, "Cannot set cursor position.", NULL);
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	Tcl_Free((char *)argv);
	return TCL_OK;
}

//
// SetwposR}h (NCAgW)
//
static int
Cwind_SetwposObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	POINT point;
	int argc;
	char **argv;
	
	if(objc != 2) {
		Tcl_WrongNumArgs(interp, 1, objv, "{x y}");
		return TCL_ERROR;
	}
	// xy𕪗
	if(Tcl_SplitList(interp, Tcl_GetString(objv[1]), &argc, &argv) != TCL_OK)
	        return TCL_ERROR;
	if(argc != 2) {
        Tcl_AppendResult(interp, "No such cursor position.", NULL);
		if(argc != 0) {
			Tcl_Free((char *)argv);
		}
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[0], (int *)&point.x) != TCL_OK) {
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	if(Tcl_GetInt(interp, argv[1], (int *)&point.y) != TCL_OK) {
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	if(ClientToScreen(GetForegroundWindow(), &point) == 0) {
		Tcl_AppendResult(interp, "Cannot convert from client to screen.", NULL);
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	if(SetCursorPos(point.x, point.y) == 0) {
		Tcl_AppendResult(interp, "Cannot set cursor position.", NULL);
		Tcl_Free((char *)argv);
		return TCL_ERROR;
	}
	Tcl_Free((char *)argv);
	return TCL_OK;
}

//
// LclickR}h
//
static int
Cwind_LclickObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	LPARAM extra = GetMessageExtraInfo();
	mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, extra);
	mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, extra);
	return TCL_OK;
}

//
// mclickR}h
//
static int
Cwind_MclickObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	LPARAM extra = GetMessageExtraInfo();
	mouse_event(MOUSEEVENTF_MIDDLEDOWN, 0, 0, 0, extra);
	mouse_event(MOUSEEVENTF_MIDDLEUP, 0, 0, 0, extra);
	return TCL_OK;
}

//
// rclickR}h
//
static int
Cwind_RclickObjCmd(
	ClientData clientData,
	Tcl_Interp *interp,
	int objc,
	Tcl_Obj *CONST objv[]
)
{
	LPARAM extra = GetMessageExtraInfo();
	mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, extra);
	mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, extra);
	return TCL_OK;
}

//
// R}h̒ǉ
//
Tcl_Command
AddCommand(
	Tcl_Interp *interp,
	char *nameSpace,
	char *cmdName,
	Tcl_ObjCmdProc *cmdProc
)
{
	char *cmdPath;
	Tcl_DString dString;
	Tcl_Command cmdToken;

	Tcl_DStringInit(&dString);

	// Namespace::Command 쐬
	if (nameSpace != NULL) {
		Tcl_DStringAppend(&dString, nameSpace, -1);
	}
	Tcl_DStringAppend(&dString, "::", -1);
	Tcl_DStringAppend(&dString, cmdName, -1);

	cmdPath = Tcl_DStringValue(&dString);
	// o^̃`FbN
	cmdToken = Tcl_FindCommand(interp, cmdPath, (Tcl_Namespace *)NULL, 0);
	if (cmdToken != NULL) {
		Tcl_DStringFree(&dString);
		return cmdToken;
	}
	// R}h̓o^
	cmdToken = Tcl_CreateObjCommand(interp, cmdPath, cmdProc, NULL, NULL);
	Tcl_DStringFree(&dString);

	Tcl_Namespace *nsPtr;
	int dontResetList = 0;

	// Namespacẽ|C^擾
	nsPtr = Tcl_FindNamespace(interp, nameSpace, (Tcl_Namespace *)NULL, TCL_LEAVE_ERR_MSG);
	if (nsPtr == NULL) {
		return NULL;
	}
	// R}hGNX|[g
	if (Tcl_Export(interp, nsPtr, cmdName, dontResetList) != TCL_OK) {
		return NULL;
	}
	return cmdToken;
}

//
// gDLL̏
//
int
Cwind_Init(
	Tcl_Interp *interp
)
{
#ifdef USE_TCL_STUBS
	// Tcl Stub̏
	if (Tcl_InitStubs(interp, "8.1", 0) == NULL) {
		return TCL_ERROR;
	}
#endif // USE_TCL_STUBS
#ifdef USE_TK_STUBS
	// Tk Stub̏
	if (Tk_InitStubs(interp, "8.1", 0) == NULL) {
		return TCL_ERROR;
	}
#endif // USE_TK_STUBS

	// Namespace̐
	Tcl_Namespace *spacePtr = Tcl_CreateNamespace(interp, NAMESPACE, (ClientData)0, (Tcl_NamespaceDeleteProc *) NULL);
	if (spacePtr == NULL) {
		return TCL_ERROR;
	}

	// R}h̒ǉ
	AddCommand(interp, NAMESPACE, "gettext", Cwind_GetTextObjCmd);
	AddCommand(interp, NAMESPACE, "send", Cwind_SendObjCmd);
	AddCommand(interp, NAMESPACE, "show", Cwind_ShowObjCmd);
	AddCommand(interp, NAMESPACE, "getcb", Cwind_GetCbObjCmd);
	AddCommand(interp, NAMESPACE, "putcb", Cwind_PutCbObjCmd);
	AddCommand(interp, NAMESPACE, "wlist", Cwind_WlistObjCmd);
	AddCommand(interp, NAMESPACE, "sleeptime", Cwind_SleeptimeObjCmd);
	AddCommand(interp, NAMESPACE, "restore", Cwind_RestoreObjCmd);
	AddCommand(interp, NAMESPACE, "minimize", Cwind_MinimizeObjCmd);
	AddCommand(interp, NAMESPACE, "maximize", Cwind_MaximizeObjCmd);
	AddCommand(interp, NAMESPACE, "state", Cwind_StateObjCmd);
	AddCommand(interp, NAMESPACE, "bottom", Cwind_BottomObjCmd);
	AddCommand(interp, NAMESPACE, "top", Cwind_TopObjCmd);
	AddCommand(interp, NAMESPACE, "topmost", Cwind_TopMostObjCmd);
	AddCommand(interp, NAMESPACE, "notopmost", Cwind_NoTopMostObjCmd);
	AddCommand(interp, NAMESPACE, "sendmessage", Cwind_SendmessageObjCmd);
	AddCommand(interp, NAMESPACE, "postmessage", Cwind_PostmessageObjCmd);
	AddCommand(interp, NAMESPACE, "getpos", Cwind_GetposObjCmd);
	AddCommand(interp, NAMESPACE, "setpos", Cwind_SetposObjCmd);
	AddCommand(interp, NAMESPACE, "getwpos", Cwind_GetwposObjCmd);
	AddCommand(interp, NAMESPACE, "setwpos", Cwind_SetwposObjCmd);
	AddCommand(interp, NAMESPACE, "lclick", Cwind_LclickObjCmd);
	AddCommand(interp, NAMESPACE, "mclick", Cwind_MclickObjCmd);
	AddCommand(interp, NAMESPACE, "rclick", Cwind_RclickObjCmd);

	// pbP[W̓o^ƃo[W̕ԋp
	return Tcl_PkgProvide(interp, PACKAGE, VERSION);
}
